/**
 * @file DistanceMatrix.cpp
 * @brief sNX
 * @author cherub
 */
#include "stdafx.h"
#include "DistanceMatrix.h"
#include <algorithm>

/**
 * @fn CDistanceMatrix::CDistanceMatrix(void)
 * @brief ftHgRXgN^
 */
CDistanceMatrix::CDistanceMatrix(void)
: CMatrix()
{
}

/**
 * @fn CDistanceMatrix::CDistanceMatrix(int row, int col)
 * @brief TCYwRXgN^
 * @param row [in] s
 * @param col [in] 
 */
CDistanceMatrix::CDistanceMatrix(int row, int col)
: CMatrix(row, col, 0)
{
}

/**
 * @fn CDistanceMatrix::CDistanceMatrix(const CDistanceMatrix &src)
 * @brief Rs[RXgN^
 * @param src [in] Rs[NXCX^X
 */
CDistanceMatrix::CDistanceMatrix(const CDistanceMatrix &src)
: CMatrix(src)
{
}

/**
 * @fn CDistanceMatrix::~CDistanceMatrix(void)
 * @brief fXgN^
 */
CDistanceMatrix::~CDistanceMatrix(void)
{
}

/**
 * @fn CDistanceMatrix& CDistanceMatrix::operator =(const CDistanceMatrix &src)
 * @brief Zq
 * @param src [in] NXCX^X
 */
CDistanceMatrix& CDistanceMatrix::operator =(const CDistanceMatrix &src)
{
	CMatrix::operator =(src);
	return *this;
}

/**
 * @fn std::vector< std::pair<int, int> > CDistanceMatrix::CalcRegistrationCurve() const
 * @brief DPŏoH̎擾 (0, 0)-->(row - 1, col - 1)
 * @return DPŏoH
 */
std::vector< std::pair<int, int> > CDistanceMatrix::CalcRegistrationCurve() const
{
	std::vector<std::pair<int, int>> path;
	CDistanceMatrix tmp(*this);

	// DP: Forward
	for (int type = 0;type < 2;++type)
	{
		int loopmax = type == 0 ? Row() : Col();
		for (int loop = 1;loop < loopmax;++loop)
		{
			int r = type == 0 ? loop : Row() - 1;
			int c = type == 0 ? 0 : loop;
			while (IsRange(r, c))
			{
				double mincost = DBL_MAX;
				if (IsRange(r - 1, c) && tmp(r - 1, c) < mincost)
					mincost = tmp(r - 1, c);
				if (IsRange(r, c - 1) && tmp(r, c - 1) < mincost)
					mincost = tmp(r, c - 1);
				if (IsRange(r - 1, c - 1) && tmp(r - 1, c - 1) < mincost)
					mincost = tmp(r - 1, c - 1);
				tmp(r, c) += mincost;
				--r;
				++c;
			}
		}
	}

	// DP: Backward
	std::pair<int, int> pos(Row() - 1, Col() - 1);
	path.push_back(pos);
	while (path.back().first != 0 || path.back().second != 0)
	{
		double mincost = DBL_MAX;
		pos = path.back();
		path.push_back(pos);
		if (IsRange(pos.first - 1, pos.second) && tmp(pos.first - 1, pos.second) < mincost)
		{
			mincost = tmp(pos.first - 1, pos.second);
			path.back().first = pos.first - 1;
			path.back().second = pos.second;
		}
		if (IsRange(pos.first, pos.second - 1) && tmp(pos.first, pos.second - 1) < mincost)
		{
			mincost = tmp(pos.first, pos.second - 1);
			path.back().first = pos.first;
			path.back().second = pos.second - 1;
		}
		if (IsRange(pos.first - 1, pos.second - 1) && tmp(pos.first - 1, pos.second - 1) < mincost)
		{
			mincost = tmp(pos.first - 1, pos.second - 1);
			path.back().first = pos.first - 1;
			path.back().second = pos.second - 1;
		}
	}

	// [i[ĂoH̔]
	std::reverse(path.begin(), path.end());
	return path;
}
