/**
 * @file TreeNode.h
 * @brief ؍\NX錾
 * @author cherub
 */
#ifndef	TREE_NODE_CLASS_HEADER_FILE_
#define	TREE_NODE_CLASS_HEADER_FILE_
#pragma once

#include <vector>

/**
 * @class CTreeNode TreeNode.h
 * @brief ؍\NX
 * @author cherub
 */
class CTreeNode
{
//
// variables
private:
	//! em[hւ̃|C^
	CTreeNode *m_pParent;
	//! qm[hւ̃|C^
	std::vector<CTreeNode*> m_vecChildren;

//
// constructor/destructor
public:
	// ftHgRXgN^
	CTreeNode(void);
	// fXgN^
	virtual ~CTreeNode();

//
// initializer
private:
	// qm[h܂ރm[h̔j
	virtual void Destroy(void);

//
// attributes
public:
	/**
	 * @fn size_t CTreeNode::NumChildren(void) const
	 * @brief qm[h擾
	 * @return qm[h
	 */
	size_t NumChildren(void) const
		{
			return m_vecChildren.size();
		}

//
// accessor
public:
	/**
	 * @fn void CTreeNode::SetParent(const CTreeNode *parent)
	 * @brief em[hݒ
	 * @param parent [in] em[hւ̃|C^
	 */
	void SetParent(const CTreeNode *parent)
		{
			m_pParent = const_cast<CTreeNode*>(parent);
		}
	/**
	 * @fn CTreeNode* CTreeNode::GetParent(void)
	 * @brief em[h擾
	 * @return em[hւ̃|C^
	 */
	CTreeNode* GetParent(void)
		{
			return m_pParent;
		}
	/**
	 * @fn const CTreeNode* CTreeNode::GetParent(void) const
	 * @brief em[h擾(const)
	 * @return em[hւ̃|C^(const)
	 */
	const CTreeNode* GetParent(void) const
		{
			return m_pParent;
		}
	// [gm[h擾
	CTreeNode* GetRoot(void);
	// [gm[h擾(const)
	const CTreeNode* GetRoot(void) const;
	// qm[h擾
	CTreeNode* GetChild(size_t nid);
	// qm[h擾(const)
	const CTreeNode* GetChild(size_t nid) const;


//
// operator
public:
	// qm[h
	size_t FindChild(const CTreeNode *node) const;
	// qm[hǉ
	void AddChild(CTreeNode *child);
	// m[h폜
	bool RemoveNode(size_t nid);
	/**
	 * @fn bool CTreeNode::RemoveNode(const CTreeNode *node)
	 * @brief m[h폜
	 * @retval true 폜
	 * @retval false 폜sC͎wm[h݂Ȃ
	 */
	bool RemoveNode(const CTreeNode *node)
		{
			return RemoveNode(FindChild(node));
		}
};

#endif //TREE_NODE_CLASS_HEADER_FILE_
